# class System::User

- System::User
- Reference
- Object

##
Overview

Represents a user on the host system.

Users can be retrieved by either username or their user ID:

    require "system/user"

    System::User.find_by name: "root"
    System::User.find_by id: "0"

##
Extended Modules

- Crystal::System::User

##
Defined in:

##
Class Method Summary

- .find_by(*, name : String)

  Returns the user associated with the given username.

- .find_by(*, id : String)

  Returns the user associated with the given ID.

- .find_by?(*, name : String)

  Returns the user associated with the given username.

- .find_by?(*, id : String)

  Returns the user associated with the given ID.

##
Instance Method Summary

- #==(other : self)

  Returns `true` if this reference is the same as other.

- #group_id : String

  The user's primary group identifier.

- #hash(hasher)

  See `Object#hash(hasher)`

- #home_directory : String

  The user's home directory.

- #id : String

  The user's identifier.

- #name : String

  The user's real or full name.

- #shell : String

  The user's login shell.

- #to_s(io)
- #username : String

  The user's username.

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, __crystal_pseudo_! : Bool __crystal_pseudo_!, __crystal_pseudo_as(type : Class) __crystal_pseudo_as, __crystal_pseudo_as?(type : Class) __crystal_pseudo_as?, __crystal_pseudo_is_a?(type : Class) : Bool __crystal_pseudo_is_a?, __crystal_pseudo_nil? : Bool __crystal_pseudo_nil?, __crystal_pseudo_responds_to?(name : Symbol) : Bool __crystal_pseudo_responds_to?, class class, dup dup, hash(hasher)
hash hash, inspect : String
inspect(io : IO) : Nil inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Class Method Detail

def self.find_by(*, name : String) #

Returns the user associated with the given username.

Raises `NotFoundError` if no such user exists.

def self.find_by(*, id : String) #

Returns the user associated with the given ID.

Raises `NotFoundError` if no such user exists.

def self.find_by?(*, name : String) #

Returns the user associated with the given username.

Returns `nil` if no such user exists.

def self.find_by?(*, id : String) #

Returns the user associated with the given ID.

Returns `nil` if no such user exists.

##
Instance Method Detail

def ==(other : self) #
Description copied from class Reference

Returns `true` if this reference is the same as other. Invokes `same?`.

def group_id : String #

The user's primary group identifier.

def hash(hasher) #
Description copied from class Reference

See `Object#hash(hasher)`

def home_directory : String #

The user's home directory.

def id : String #

The user's identifier.

def name : String #

The user's real or full name.

def shell : String #

The user's login shell.

def to_s(io) #
def username : String #

The user's username.